#! /bin/sh

if [ -z "$JAVA_HOME" ] ; then
  JAVA=`which java`
  if [ -z "$JAVA" ] ; then
    echo "Cannot find JAVA. Please set your PATH."
    exit 1
  fi
  JAVA_BIN=`dirname $JAVA`
  JAVA_HOME=$JAVA_BIN/..
fi

if [ -f "soapclient.jar" ] ; then
   mv soapclient.jar soapclient.jar.old
fi

if [ -f "soapclient/ResponseMessage.class" ] ; then
   rm soapclient/*.class
fi

JAVAC=$JAVA_HOME/bin/javac
JAR=$JAVA_HOME/bin/jar

CLASSPATH=`echo servlet/lib/*.jar | tr ' ' ':'`
CLASSPATH=servlet/lib/ant_1.3.jar:$CLASSPATH:$JAVA_HOME/lib/tools.jar


$JAVAC -classpath $CLASSPATH soapclient/*.java

if [ -f "soapclient/ResponseMessage.class" ] ; then
   echo "success, creating jar file"
   $JAR cvf soapclient.jar soapclient/*.class
else
   echo "build not successful"
   mv soapclient.jar.old soapclient.jar
fi
