/*
 * Authority.java - load representation of Authority object.
 *
 *		Note: this is only a shell for the authority
 *		fixed field handlers, all need to be specified
 *		by going through the latest specs
 *
 * 		Art Rhyno (arhyno@uwindsor.ca), Sept. 2002
 *		(c) Copyright GNU General Public License (GPL)
 *
 * 		Revised:
 *
 */


//PYTHEAS
package pytheas;

//Standard Java
import java.util.Date;
import java.util.Vector;
import java.util.Enumeration;

//Castor
import org.exolab.castor.jdo.Database;
import org.exolab.castor.jdo.Persistent;
import org.exolab.castor.jdo.TimeStampable;


//Authority extends MARC mapping
public class Authority 
	extends Marc implements Persistent, TimeStampable
{

	private String		_recordStatus;
 
	private Date		_creationTime;

	private Date		_modificationTime;

	private long		_timeStamp;

	public void setRecordStatus( String recordStatus )
    	{
        	_recordStatus = recordStatus;
    	}//setRecordStatus

	public String getRecordStatus()
    	{
        	return _recordStatus;
    	}//getRecordStatus

	public void setCreationTime( Date creationTime )
    	{
        	_creationTime = creationTime;
    	}//setCreationTime

    	public Date getCreationTime()
    	{
        	return _creationTime;
    	}//getCreationTime


    	public void setModificationTime( Date modificationTime )
    	{
        	_modificationTime = modificationTime;
    	}//setModificationTime

    	public Date getModificationTime()
    	{
        	return _modificationTime;
    	}//getModificationTime

    	public long jdoGetTimeStamp()
    	{
        	return _timeStamp;
    	}//jdoGetTimeStamp

    	public void jdoSetTimeStamp( long timeStamp )
    	{
        	_timeStamp = timeStamp;
    	}//jdoSetTimeStamp

}//Authority
