/*
 * Basename.java - load representation of basename object.
 *
 * 		Art Rhyno (arhyno@uwindsor.ca), Sept. 2002
 *		(c) Copyright GNU General Public License (GPL)
 *
 * 		Revised:
 *
 */

//PYTHEAS
package pytheas;

//Standard Java
import java.util.Date;
import java.util.Collection;
import java.util.Enumeration;

//Castor
import org.exolab.castor.jdo.Database;
import org.exolab.castor.jdo.Persistent;
import org.exolab.castor.jdo.TimeStampable;

public class Basename implements Persistent, TimeStampable
{

	private int		_id;

	private Database  	_db;

	private String		_baseNameString;

	private Topic 		_topic;

	private Collection 	_variants;

	private Date     	_creationTime;

    	private Date		_modificationTime;

	private long		_timeStamp;

	public int getId()
    	{
        	return _id;
    	}//getId

    	public void setId( int id )
    	{
        	_id = id;
    	}//setId

	public String getBaseNameString()
    	{
        	return _baseNameString;
    	}//getBaseNameString

    	public void setBaseNameString( String baseNameString )
    	{
        	_baseNameString = baseNameString;
    	}//setBaseNameString

    	public Topic getTopic()
    	{
        	return _topic;
    	}//getTopic

    	public void setTopic( Topic topic )
    	{
        	_topic = topic;
    	}//setTopic

    	public Collection getVariants()
    	{
        	return _variants;
    	}//getVariants

    	public void setVariants( Collection variants)
    	{
        	_variants = variants;
    	}//setVariants

    	public void jdoPersistent( Database db )
    	{
        	_db = db;
    	}//jdoPersistent

    	public void jdoTransient()
    	{
        	_db = null;
    	}//jdoTransient

    	public Class jdoLoad(short accessMode)
    	{
		return Basename.class;
    	}//jdoLoad

    	public void jdoBeforeCreate( Database db )
    	{
        	_creationTime = new Date();
    	}//jdoBeforeCreate

    	public void jdoAfterCreate()
    	{
    	}//jdoAfterCreate

    	public void jdoStore(boolean modified)
    	{
	       	if ( modified )
			_modificationTime = new Date();
    	}//jdoStore

    	public void jdoBeforeRemove()
    	{
    	}//jdoBeforeRemove

    	public void jdoAfterRemove()
    	{
    	}//jdoAfterRemove

    	public void jdoUpdate()
    	{
    	}//jdoUpdate

    	public void setCreationTime( Date creationTime )
    	{
        	_creationTime = creationTime;
    	}//setCreationTime

    	public Date getCreationTime()
    	{
        	return _creationTime;
    	}//getCreationTime

    	public void setModificationTime( Date modificationTime )
    	{
        	_modificationTime = modificationTime;
    	}//setModificationTime

    	public Date getModificationTime()
    	{
        	return _modificationTime;
    	}//getModificationTime

    	public long jdoGetTimeStamp()
    	{
        	return _timeStamp;
    	}//jdoGetTimeStamp

    	public void jdoSetTimeStamp( long timeStamp )
    	{
        	_timeStamp = timeStamp;
    	}//jdoSetTimeStamp

}//Basename
