/*
 * Bib.java - load representation of Bibliographic object.
 *
 * 		Art Rhyno (arhyno@uwindsor.ca), Aug. 2000
 *		(c) Copyright GNU General Public License (GPL)
 *
 * 		Revised:
 *			Aug. 2002 - changed to add holdings
 *
 */

//PYTHEAS
package pytheas;

//Standard Java
import java.util.Collection;
import java.util.Date;
import java.util.Vector;
import java.util.Enumeration;

//Castor
import org.exolab.castor.jdo.Database;
import org.exolab.castor.jdo.Persistent;
import org.exolab.castor.jdo.TimeStampable;

public class Bib 
    extends Marc implements Persistent, TimeStampable
{

	//Bibs hang of a Resource
	private Resource 	_resource;

	//Bib mappings, will need more for MARC 21
	private String  	_origNo;
	private String  	_recordStatus;
	private String  	_recordType;
	private String  	_encodingLevel;
	private String  	_desCatForm;
	private String  	_typeDate;
	private String  	_begPubDate;
	private String  	_endPubDate;
    	private String  	_pubPlace;
    	private String  	_illCode;
    	private String  	_targetAud;
    	private String  	_itemForm;
    	private String  	_contNature;
    	private String  	_govCode;
    	private String  	_confCode;
    	private String  	_festschrift;
    	private String  	_ownIndex;
    	private String  	_fiction;
    	private String  	_biography;
    	private String  	_langCode;

	//Bib has "one to many" relationship to holdings records
    	private Collection 	_holdings;

    	private Date		_creationTime;
	private Date		_modificationTime;
    	private long		_timeStamp;

	public Resource getResource()
    	{
        	return _resource;
    	}//getResource

	public void setResource( Resource resource )
    	{
        	_resource = resource;
    	}//setResource

    	public String getOrigNo()
    	{
        	return _origNo;
    	}//getOrigNo

	public void setOrigNo( String origNo )
    	{
        	_origNo = origNo;
    	}//setOrigNo

	public String getRecordStatus()
    	{
        	return _recordStatus;
    	}//getRecordStatus

	public void setRecordStatus( String recordStatus )
    	{
        	_recordStatus = recordStatus;
    	}//setRecordStatus

	public String getRecordType()
    	{
        	return _recordType;
    	}//getRecordType

	public void setRecordType( String recordType )
    	{
        	_recordType = recordType;
    	}//setRecordType

    	public String getEncodingLevel()
    	{
        	return _encodingLevel;
    	}//getEncodingLevel

    	public void setEncodingLevel( String encodingLevel )
    	{
        	_encodingLevel = encodingLevel;
    	}//setEncodingLevel

    	public String getDesCatForm()
    	{
        	return _desCatForm;
    	}//getDesCatForm

    	public void setDesCatForm( String desCatForm )
    	{
        	_desCatForm = desCatForm;
    	}//setDesCatForm

    	public String getTypeDate()
    	{
        	return _typeDate;
    	}//getTypeDate

    	public void setTypeDate( String typeDate )
    	{
        	_typeDate = typeDate;
    	}//setTypeDate

    	public String getBegPubDate()
    	{
        	return _begPubDate;
    	}//getBegPubDate

    	public void setBegPubDate( String begPubDate )
    	{
        	_begPubDate = begPubDate;
    	}//setBegPubDate

    	public String getEndPubDate()
    	{
        	return _endPubDate;
    	}//getEndPubDate

    	public void setEndPubDate( String endPubDate )
    	{
        	_endPubDate = endPubDate;
    	}//setEndPubDate

    	public String getPubPlace()
    	{
        	return _pubPlace;
    	}//getPubPlace

    	public void setPubPlace( String pubPlace )
    	{
        	_pubPlace = pubPlace;
    	}//setPubPlace

    	public String getIllCode()
    	{
        	return _illCode;
    	}//getIllCode

    	public void setIllCode( String illCode )
    	{
        	_illCode = illCode;
    	}//setIllCode

    	public String getTargetAud()
    	{
        	return _targetAud;
    	}//getTargetAud

    	public void setTargetAud( String targetAud )
    	{
        	_targetAud = targetAud;
    	}//setTargetAud

    	public String getItemForm()
    	{
        	return _itemForm;
    	}//getItemForm

    	public void setItemForm( String itemForm )
    	{
        	_itemForm = itemForm;
    	}//setItemForm

    	public String getContNature()
    	{
        	return _contNature;
    	}//getContNature

    	public void setContNature( String contNature )
    	{
        	_contNature = contNature;
    	}//setContNature

    	public String getGovCode()
    	{
        	return _govCode;
    	}//getGovCode

    	public void setGovCode( String govCode )
    	{
        	_govCode = govCode;
    	}//setGovCode

    	public String getConfCode()
    	{
        	return _confCode;
    	}//getConfCode

    	public void setConfCode( String confCode )
    	{
        	_confCode = confCode;
    	}//setConfCode

    	public String getFestschrift()
    	{
        	return _festschrift;
    	}//getFestschrift

    	public void setFestschrift( String festschrift )
    	{
        	_festschrift = festschrift;
    	}//setFestschrift

    	public String getOwnIndex()
    	{
        	return _ownIndex;
    	}//getOwnIndex

    	public void setOwnIndex( String ownIndex )
    	{
        	_ownIndex = ownIndex;
    	}//setOwnIndex

    	public String getFiction()
    	{
        	return _fiction;
    	}//getFiction

    	public void setFiction( String fiction )
    	{
        	_fiction = fiction;
    	}//setFiction

    	public String getBiography()
    	{
        	return _biography;
    	}//getBiography

    	public void setBiography( String biography )
    	{
        	_biography = biography;
    	}//setBiography

    	public String getLangCode()
    	{
        	return _langCode;
    	}//getLangCode

    	public void setLangCode( String langCode )
    	{
        	_langCode = langCode;
    	}//setLangCode

    	public Collection getHoldings()
    	{
        	return _holdings;
    	}//getHoldings

    	public void setHoldings( Collection holdings )
    	{
		_holdings = holdings;
    	}//setHoldings

    	public void setCreationTime( Date creationTime )
    	{
        	_creationTime = creationTime;
    	}//setCreationTime

    	public Date getCreationTime()
    	{
        	return _creationTime;
    	}//getCreationTime

    	public void setModificationTime( Date modificationTime )
    	{
        	_modificationTime = modificationTime;
    	}//setModificationTime

    	public Date getModificationTime()
    	{
        	return _modificationTime;
    	}//getModicationTime

    	public long jdoGetTimeStamp()
    	{
        	return _timeStamp;
    	}//jdoGetTimeStamp

    	public void jdoSetTimeStamp( long timeStamp )
    	{
        	_timeStamp = timeStamp;
    	}//jdoSetTimeStamp

}//Bib
