/*
 * CrosswalkEntry.java - objects and associated parsers for rules.
 *
 * 		Art Rhyno (arhyno@uwindsor.ca), June 1999
 *		(c) Copyright GNU General Public License (GPL)
 *
 * 		Revised:
 *			Aug. 2002 - changed for topic map additions
 *
 */

//PYTHEAS
package pytheas;
 
public class CrosswalkEntry 
{
	String		predicateName, crosswalkName;
	String 		ind1, ind2;
    	String 		marker;
    	String 		ruleSpec;
    	String 		holdSubfs;

    	boolean 	subfieldFlag = false;
    	boolean 	indicator1Flag = false;
    	boolean 	indicator2Flag = false;
    	boolean 	ruleFlag = false;
    
    	CrosswalkEntry(String newParm) 
    	{
		int 	i,j;
	
		// work with funky rule syntax, e.g. DC.Title:245 0@$a
		i = newParm.indexOf(".");	
		if (i > 0)
	    		crosswalkName = new String(newParm.substring(0,i));

		j = (newParm.indexOf(":") - i) + 2;
		if (j > 0)
	    		predicateName = new String(newParm.substring(++i,j));	

		if (i > 0 && j > 0)
	    		ruleSpec = new String(newParm.substring(++j));	    
    	}//CrosswalkEntry - constructor
    
	public String returnPredicate()
    	{
		return predicateName;
    	}//returnPredicate
    
    	public String returnRule()
    	{
		return ruleSpec;
    	}//returnRule
    
    	public String returnCrosswalk()
    	{
		return crosswalkName;
    	}//return Crosswalk
    
    	public void setInd(String indValues)
    	{
		ind1 = new String(indValues.substring(0,1));
		if (ind1.indexOf("@") != 0)
		    indicator1Flag = true;
		ind2 = new String(indValues.substring(1));
		if (ind2.indexOf("@") != 0)
		    indicator2Flag = true;
    	}//setInd
    
    	public String returnInd1()
    	{
		return ind1;
    	}//returnInd1
    
    	public String returnInd2()
    	{
		return ind2;
    	}//returnInd2
    
    	public void setSubf(String subfValue)
    	{
		holdSubfs = new String(subfValue);
		subfieldFlag = true;
    	}//setSubf
    
    	public String returnSubf()
    	{
		return holdSubfs;
    	}//returnSubf
    
    	public boolean isSubf()
    	{
		return subfieldFlag;
    	}//isSubf
    
    	public boolean isIndicator1()
    	{
		return indicator1Flag;
    	}//isIndicator1
    
    	public boolean isIndicator2()
    	{
		return indicator2Flag;
    	}//isIndicator2
    
    	public boolean ruleSet()
    	{
		return ruleFlag;
    	}//ruleSet
    
    	public void setRule()
    	{
		ruleFlag = true;
    	}//setRule

}//CrosswalkEntry
