/*
 * HeadingEntry.java - names and associated resources for headings
 *
 * 		Art Rhyno (arhyno@uwindsor.ca), Sept. 2001
 *		(c) Copyright GNU General Public License (GPL)
 *
 * 		Revised:
 *			Aug. 2002 - added some plumbing for Topic Maps
 *
 */

package pytheas;

import java.util.Vector;
 
public class HeadingEntry 
{
	String	headingName;
	Vector	resourceIds;
	Vector	topicMapIds;
    
    	HeadingEntry(String theHeading, int theResource, int theTopicMap) 
    	{
	
		headingName = theHeading;
		resourceIds = new Vector();
		resourceIds.addElement(new Integer(theResource));

		topicMapIds = new Vector();
		topicMapIds.addElement(new Integer(theTopicMap));
    	}//HeadingEntry Constructor
    
	public String returnHeading()
    	{
		return headingName;
    	}//returnHeading
    
    	public void addResource(int theResource)
    	{
		Integer checkResource = new Integer(theResource);
		if (!resourceIds.contains(checkResource))
			resourceIds.addElement(new Integer(theResource));
    	}//addResource
    
	public Vector returnResources()
    	{
		return resourceIds;
    	}//returnResources

    	public void addTopicMap(int theTopicMap)
    	{
		Integer checkTopicMap = new Integer(theTopicMap);
		if (!topicMapIds.contains(checkTopicMap))
			topicMapIds.addElement(new Integer(theTopicMap));
    	}//addTopicMap
    
    	public Vector returnTopicMaps()
    	{
		return topicMapIds;
    	}//returnTopicMaps
    
}//HeadingEntry
