/*
 * Marc.java - load representation of MARC object.
 *
 * 		Art Rhyno (arhyno@uwindsor.ca), Aug. 1999
 *		(c) Copyright GNU General Public License (GPL)
 *
 *		Note: this is the base class for all other MARC
 *			records.
 *
 * 		Revised:
 *			Aug. 2001 - changed for authorities 
 *				(associated with Resource)
 *
 */

//PYTHEAS
package pytheas;

//Standard Java
import java.util.Collection;
import java.util.Date;
import java.util.Enumeration;

//Castor
import org.exolab.castor.jdo.Database;
import org.exolab.castor.jdo.Persistent;
import org.exolab.castor.jdo.TimeStampable;

public class Marc implements Persistent, TimeStampable
{

	private int		_id;

	private Database	_db;

    	private Collection	_vartags;

    	private Date		_creationTime;

    	private Date		_modificationTime;

    	private long		_timeStamp;

    	public int getId()
    	{
        	return _id;
    	}//getId

    	public void setId( int id )
    	{
        	_id = id;
    	}//setId

    	public MarcVarTag createVarTag()
    	{
        	return new MarcVarTag();
    	}//createVarTag

    	public Collection getVartags()
    	{
        	return _vartags;
    	}//getVartags

    	public void setVartags( Collection vartags )
    	{
		_vartags = vartags;
    	}//setVartags

    	public void jdoPersistent( Database db )
    	{
        	_db = db;
    	}//jdoPersistent

    	public void jdoTransient()
    	{
        	_db = null;
    	}//jdoTransient

    	public Class jdoLoad(short accessMode)
    	{
		return Marc.class;
    	}//jdoLoad

    	public void jdoBeforeCreate( Database db )
    	{
        	_creationTime = new Date();
    	}//jdoBeforeCreate

    	public void jdoAfterCreate()
    	{
    	}//jdoAfterCreate

    	public void jdoStore(boolean modified)
    	{
       		if ( modified )
            		_modificationTime = new Date();
    	}//jdoStore

    	public void jdoBeforeRemove()
    	{
    	}//jdoBeforeRemove

    	public void jdoAfterRemove()
    	{
    	}//jdoAfterRemove

    	public void jdoUpdate()
    	{
    	}//jdoUpdate

    	public String toString()
    	{
		return "MARC ID: " + _id + " & varTags: " + _vartags.size();
    	}//toString

    	public void setCreationTime( Date creationTime )
    	{
        	_creationTime = creationTime;
    	}//setCreationTime

    	public Date getCreationTime()
    	{
        	return _creationTime;
    	}//getCreationTime

    	public void setModificationTime( Date modificationTime )
    	{
        	_modificationTime = modificationTime;
    	}//setModificationTime

    	public Date getModificationTime()
    	{
        	return _modificationTime;
    	}//getModificationTime

    	public long jdoGetTimeStamp()
    	{
        	return _timeStamp;
    	}//jdoGetTimeStamp

    	public void jdoSetTimeStamp( long timeStamp )
    	{
        	_timeStamp = timeStamp;
    	}//jdoSetTimeStamp

}//Marc
