/*
 * MarcVarTag.java - load representation of MarcVarTag object.
 *
 * 		Art Rhyno (arhyno@uwindsor.ca), Aug. 1999
 *		(c) Copyright GNU General Public License (GPL)
 *
 * 		Revised:
 *
 */

package pytheas;

//Standard Java
import java.util.Date;
import java.util.Collection;
import java.util.Enumeration;

//Castor
import org.exolab.castor.jdo.Database;
import org.exolab.castor.jdo.Persistent;
import org.exolab.castor.jdo.TimeStampable;


public class MarcVarTag implements Persistent, TimeStampable
{

	private int		_id;

	private boolean		_controlFlag;

    	private String		_uri;

    	private Database	_db;

    	private Marc  		_marc;

    	private String       	_tagName;

    	private String       	_ind1;

    	private String		_ind2;

	private Collection	_subfs;

	private Date		_creationTime;

    	private Date		_modificationTime;

	private long		_timeStamp;

    	public int getId()
    	{
        	return _id;
    	}//getId

    	public MarcVarTagSubf createSubf()
    	{
        	return new MarcVarTagSubf();
    	}//createSubf

    	public Collection getSubfs()
    	{
        	return _subfs;
    	}//getSubfs

    	public void setSubfs( Collection subfs )
    	{
		_subfs = subfs;
    	}//setSubfs

    	public void setId( int id )
    	{
        	_id = id;
    	}//setId

    	public String getTagName()
    	{
        	return _tagName;
    	}//getTagName

    	public void setTagName ( String tagName )
    	{
        	_tagName = tagName;
    	}//setTagName

    	public String getInd1()
    	{
        	return _ind1;
    	}//getInd1

    	public void setInd1( String ind1 )
    	{
        	_ind1 = ind1;
    	}//setInd1

    	public String getInd2()
    	{
        	return _ind2;
    	}//getInd2

    	public void setInd2( String ind2 )
    	{
        	_ind2 = ind2;
    	}//setInd2

    	public boolean getControlFlag()
    	{
        	return _controlFlag;
    	}//getControlFlag

    	public void setControlFlag( boolean controlFlag )
    	{
        	_controlFlag = controlFlag;
    	}//setControlFlag

    	public String getControlUri()
    	{
        	return _uri;
    	}//getControlUri

    	public void setControlUri ( String uri )
    	{
        	_uri = uri;
    	}//setControlUri

    	public Marc getMarc()
    	{
        	return _marc;
    	}//getMarc

    	public void setMarc( Marc marc )
    	{
        	_marc = marc;
    	}//setMarc

    	public String toString()
    	{
        	return _tagName + " " + _ind1 + _ind2;
    	}//toString

    	public void jdoPersistent( Database db )
    	{
        	_db = db;
    	}//jdoPersistent

    	public void jdoTransient()
    	{
        	_db = null;
    	}//jdoTransient

    	public Class jdoLoad(short accessMode)
    	{
		return MarcVarTag.class;
    	}//jdoLoad

    	public void jdoBeforeCreate( Database db )
    	{
        	_creationTime = new Date();
    	}//jdoBeforeCreate

    	public void jdoAfterCreate()
    	{
    	}//jdoAfterCreate

    	public void jdoStore(boolean modified)
    	{
       		if ( modified )
            		_modificationTime = new Date();
    	}//jdoStore

    	public void jdoBeforeRemove()
    	{
    	}//jdoBeforeRemove

    	public void jdoAfterRemove()
    	{
    	}//jdoAfterRemove

    	public void jdoUpdate()
    	{
    	}//jdoUpdate

    	public void setCreationTime( Date creationTime )
    	{
        	_creationTime = creationTime;
    	}//setCreationTime

    	public Date getCreationTime()
    	{
        	return _creationTime;
    	}//getCreationTime

    	public void setModificationTime( Date modificationTime )
    	{
        	_modificationTime = modificationTime;
    	}//setModificationTime

    	public Date getModificationTime()
    	{
        	return _modificationTime;
    	}//getModificationTime

    	public long jdoGetTimeStamp()
    	{
        	return _timeStamp;
    	}//jgoGetTimeStamp

    	public void jdoSetTimeStamp( long timeStamp )
    	{
        	_timeStamp = timeStamp;
    	}//jdoSetTimeStamp

}//MarcVarTag

