/*
 * Member.java - load representation of member object for Topic Map.
 *
 * 		Art Rhyno (arhyno@uwindsor.ca), Sept. 2002
 *		(c) Copyright GNU General Public License (GPL)
 *
 * 		Revised:
 *
 */

package pytheas;

//Standard Java
import java.util.Date;
import java.util.Collection;
import java.util.Enumeration;

//Castor
import org.exolab.castor.jdo.Database;
import org.exolab.castor.jdo.Persistent;
import org.exolab.castor.jdo.TimeStampable;

public class Member implements Persistent, TimeStampable
{

	private int		_id;

	private Database  	_db;

    	private String		_topicIdent;

    	private String		_roleIdent;

    	private int 		_thisTopic;

    	private int 		_thisRole;

    	private Associations 	_association;

    	private Date     	_creationTime;

    	private Date     	_modificationTime;

    	private long     	_timeStamp;

    	public int getId()
    	{
        	return _id;
    	}//getId

    	public void setId( int id )
    	{
        	_id = id;
    	}//setId

    	public String getTopicIdent()
    	{
        	return _topicIdent;
    	}//getTopicIdent

    	public void setTopicIdent( String topicIdent )
    	{
        	_topicIdent = topicIdent;
    	}//setTopicIdent

    	public int getThisTopic()
    	{
        	return _thisTopic;
    	}//getThisTopic

    	public void setThisTopic ( int thisTopic )
    	{
        	_thisTopic = thisTopic;
    	}//setThisTopic

    	public String getRoleIdent()
    	{
        	return _roleIdent;
    	}//getRoleIdent

    	public void setRoleIdent( String roleIdent )
    	{
        	_roleIdent = roleIdent;
    	}//setRoleIdent

    	public int getThisRole()
    	{
        	return _thisRole;
    	}//getThisRole

    	public void setThisRole ( int thisRole )
    	{
        	_thisRole = thisRole;
    	}//setThisRole

    	public Associations getAssociation()
    	{
        	return _association;
    	}//getAssociation

    	public void setAssociation( Associations association)
    	{
        	_association = association;
    	}//setAssociation

    	public void jdoPersistent( Database db )
    	{
        	_db = db;
    	}//jdoPersistent

    	public void jdoTransient()
    	{
        	_db = null;
    	}//jdoTransient

    	public Class jdoLoad(short accessMode)
    	{
		return Member.class;
    	}//jdoLoad

    	public void jdoBeforeCreate( Database db )
    	{
        	_creationTime = new Date();
    	}//jdoBeforeCreate

    	public void jdoAfterCreate()
    	{
    	}//jdoAfterCreate

    	public void jdoStore(boolean modified)
    	{
       		if ( modified )
            		_modificationTime = new Date();
    	}//jdoStore

    	public void jdoBeforeRemove()
    	{
    	}//jdoBeforeRemove

    	public void jdoAfterRemove()
    	{
    	}//jdoAfterRemove

    	public void jdoUpdate()
    	{
    	}//jdoUpdate

    	public void setCreationTime( Date creationTime )
    	{
        	_creationTime = creationTime;
    	}//setCreationTime

    	public Date getCreationTime()
    	{
        	return _creationTime;
    	}//getCreationTime

    	public void setModificationTime( Date modificationTime )
    	{
        	_modificationTime = modificationTime;
    	}//setModificationTime

    	public Date getModificationTime()
    	{
        	return _modificationTime;
    	}//getModificationTime

    	public long jdoGetTimeStamp()
    	{
        	return _timeStamp;
    	}//jdoGetTimeStamp

    	public void jdoSetTimeStamp( long timeStamp )
    	{
        	_timeStamp = timeStamp;
    	}//jdoSetTimeStamp

}//Member
