/*
 * Parm.java - load representation of Parm object.
 *
 * 		Art Rhyno (arhyno@uwindsor.ca), Sept. 2002
 *		(c) Copyright GNU General Public License (GPL)
 *
 * 		Revised:
 *
 */

//PYTHEAS
package pytheas;

//Standard
import java.util.Date;
import java.util.Collection;
import java.util.Enumeration;

//Castor
import org.exolab.castor.jdo.Database;
import org.exolab.castor.jdo.Persistent;
import org.exolab.castor.jdo.TimeStampable;

public class Parm implements Persistent, TimeStampable
{

	private int		_id;

    	private Database  	_db;

    	private String    	_topicIdent;

    	private int 		_thisTopic;

    	private Variant 	_variant;

    	private Collection 	_scopes;

    	private Date     	_creationTime;

    	private Date     	_modificationTime;

    	private long     	_timeStamp;

    	public int getId()
    	{
        	return _id;
    	}//getId

    	public void setId( int id )
    	{
        	_id = id;
    	}//setId

    	public String getTopicIdent()
    	{
        	return _topicIdent;
    	}//getTopicIdent

    	public void setTopicIdent( String topicIdent )
    	{
        	_topicIdent = topicIdent;
    	}//setTopicIdent

    	public Variant getVariant()
    	{
        	return _variant;
    	}//getVariant

    	public void setVariant( Variant variant )
    	{
        	_variant = variant;
    	}//setVariant

    	public int getThisTopic()
    	{
        	return _thisTopic;
    	}//getThisTopic

    	public void setThisTopic ( int thisTopic )
    	{
        	_thisTopic = thisTopic;
    	}//setThisTopic

    	public Collection getScopes()
    	{
        	return _scopes;
    	}//getScopes

    	public void setScopes( Collection scopes)
    	{
        	_scopes = scopes;
    	}//setScopes

    	public void jdoPersistent( Database db )
    	{
        	_db = db;
    	}//jdoPersistent

    	public void jdoTransient()
    	{
        	_db = null;
    	}//jdoTransient

    	public Class jdoLoad(short accessMode)
    	{
		return Parm.class;
    	}//jdoLoad

    	public void jdoBeforeCreate( Database db )
    	{
        	_creationTime = new Date();
    	}//jdoBeforeCreate

    	public void jdoAfterCreate()
    	{
    	}//jdoAfterCreate

    	public void jdoStore(boolean modified)
    	{
       		if ( modified )
            		_modificationTime = new Date();
    	}//jdoStore

    	public void jdoBeforeRemove()
    	{
    	}//jdoBeforeRemove

    	public void jdoAfterRemove()
    	{
    	}//jdoAfterRemove

    	public void jdoUpdate()
    	{
    	}//jdoUpdate

    	public void setCreationTime( Date creationTime )
    	{
        	_creationTime = creationTime;
    	}//setCreationTime

    	public Date getCreationTime()
    	{
        	return _creationTime;
    	}//getCreationTime

    	public void setModificationTime( Date modificationTime )
    	{
        	_modificationTime = modificationTime;
    	}//setModificationTime

    	public Date getModificationTime()
    	{
        	return _modificationTime;
    	}//getModificationTime

    	public long jdoGetTimeStamp()
    	{
        	return _timeStamp;
    	}//jdoGetTimeStamp

    	public void jdoSetTimeStamp( long timeStamp )
    	{
        	_timeStamp = timeStamp;
    	}//jdoSetTimeStamp

}//Parm
