/*
 * Rdf.java - load representation of RDF object.
 *
 * 		Art Rhyno (arhyno@uwindsor.ca), Aug. 1999
 *		(c) Copyright GNU General Public License (GPL)
 *
 * 		Revised:
 *			Aug. 2001 - started to deal with sequences and
 *				collections
 */

package pytheas;

//Standard
import java.util.Date;
import java.util.Vector;
import java.util.Enumeration;

//Castor
import org.exolab.castor.jdo.Database;
import org.exolab.castor.jdo.Persistent;
import org.exolab.castor.jdo.TimeStampable;

public class Rdf implements Persistent, TimeStampable
{

	private int		_id;

    	private boolean 	_isType;

    	private boolean 	_isBag;

    	private boolean 	_isOrd;

    	private int		_seqNo;

    	private int		_bagNo;
    
    	private int         	_subject;

    	private String       	_predicate;

    	private String       	_value;

    	private String       	_nameSpace;

    	private String       	_nameCode;

    	private String       	_normalEntry;

    	private Resource 	_resource;

    	private Database     	_db;

    	private Date     	_creationTime;

    	private Date     	_modificationTime;

    	private long     	_timeStamp;

    	public int getId()
    	{
        	return _id;
    	}//getId

	public void setId( int id )
    	{
        	_id = id;
    	}//setId

    	public int getSubject()
    	{
        	return _subject;
    	}//getSubject

    	public void setSubject( int subject )
    	{
        	_subject = subject;
    	}//setSubject

    	public boolean getIsType()
    	{
        	return _isType;
    	}//getIsType

    	public void setIsType( boolean isType )
    	{
        	_isType = isType;
    	}//setIsType

    	public boolean getIsBag()
    	{
        	return _isBag;
    	}//getIsBag

    	public void setIsBag( boolean isBag )
    	{
        	_isBag = isBag;
    	}//setIsBag

    	public boolean getIsOrd()
    	{
        	return _isOrd;
    	}//getIsOrd

    	public void setIsOrd( boolean isOrd )
    	{
        	_isOrd = isOrd;
    	}//setIsOrd

    	public int getSeqNo()
    	{
        	return _seqNo;
    	}//getSeqNo

    	public void setSeqNo( int seqNo )
    	{
        	_seqNo = seqNo;
    	}//setSeqNo

    	public int getBagNo()
    	{
        	return _bagNo;
    	}//getBagNo

    	public void setBagNo( int bagNo )
    	{
        	_bagNo = bagNo;
    	}//setBagNo

    	public String getPredicate()
    	{
        	return _predicate;
    	}//getPredicate

    	public void setPredicate( String predicate )
    	{
        	_predicate = predicate;
    	}//setPredicate

    	public String getValue()
    	{
        	return _value;
    	}//getValue

    	public void setValue( String value )
    	{
        	_value = value;
    	}//setValue

    	public String getNameSpace()
    	{
        	return _nameSpace;
    	}//getNameSpace

    	public void setNameSpace( String nameSpace )
    	{
        	_nameSpace = nameSpace;
    	}//setNameSpace

    	public String getNameCode()
    	{
        	return _nameCode;
    	}//getNameCode

    	public void setNameCode( String nameCode )
    	{
        	_nameCode = nameCode;
    	}//setNameCode

    	public String getNormalEntry()
    	{
        	return _normalEntry;
    	}//getNormalEntry

    	public void setNormalEntry( String normalEntry )
    	{
        	_normalEntry = normalEntry;
    	}//setNormalEntry

    	public Resource getResource()
    	{
        	return _resource;
    	}//getResource

    	public void setResource( Resource resource)
    	{
        	_resource = resource;
    	}//setResource

    	public void jdoPersistent( Database db )
    	{
        	_db = db;
    	}//jdoPersistent

    	public void jdoTransient()
    	{
        	_db = null;
    	}//jdoTransient

    	public Class jdoLoad(short accessMode)
    	{
        	return Rdf.class;
    	}//jdoLoad

    	public void jdoBeforeCreate( Database db )
    	{
		_creationTime = new Date();
    	}//jdoBeforeCreate

    	public void jdoAfterCreate()
    	{
    	}//jdoAfterCreate

    	public void jdoStore(boolean modified)
    	{
        	if ( modified )
            		_modificationTime = new Date();
    	}//jdoStore

    	public void jdoBeforeRemove()
    	{
    	}//jdoBeforeRemove

    	public void jdoAfterRemove()
    	{
    	}//jdoAfterRemove

    	public void jdoUpdate()
    	{
    	}//jdoUpdate

    	public String toString()
    	{
        	return _predicate + " = " + _value;
    	}//toString

    	public void setCreationTime( Date creationTime )
    	{
        	_creationTime = creationTime;
    	}//setCreationTime

    	public Date getCreationTime()
    	{
        	return _creationTime;
    	}//getCreationTime

    	public void setModificationTime( Date modificationTime )
    	{
        	_modificationTime = modificationTime;
    	}//setModificationTime

    	public Date getModificationTime()
    	{
        	return _modificationTime;
    	}//getModificationTime

    	public long jdoGetTimeStamp()
    	{
        	return _timeStamp;
    	}//jdoGetTimeStamp

    	public void jdoSetTimeStamp( long timeStamp )
    	{
        	_timeStamp = timeStamp;
    	}//jdoSetTimeStamp
}//Rdf
