/*
 * Resource.java - load representation of Resource object.
 *
 * 		Art Rhyno (arhyno@uwindsor.ca), Aug. 1999
 *		(c) Copyright GNU General Public License (GPL)
 *
 * 		Revised:
 *			Aug. 2001 - started to deal with sequences and
 *				collections
 */

//PYTHEAS
package pytheas;


//Standard
import java.util.Date;
import java.util.Collection;
import java.util.Enumeration;

//Castor
import org.exolab.castor.jdo.Database;
import org.exolab.castor.jdo.Persistent;
import org.exolab.castor.jdo.TimeStampable;

public class Resource implements Persistent, TimeStampable
{

	private int		_id;

    	private Database  	_db;

    	private String		_uri;

    	private byte[]		_blob;

    	private Collection	_names;

    	private Collection	_subjects;

    	private Collection	_webonts;

	private Collection	_rdfs;

	private Date		_creationTime;

	private Date		_modificationTime;

	private long		_timeStamp;

	public int getId()
    	{
        	return _id;
    	}//getId

	public void setId( int id )
    	{
        	_id = id;
    	}//setId

    	public String getUri()
    	{
        	return _uri;
    	}//getUri

    	public void setUri( String uri )
    	{
        	_uri = uri;
    	}//setUri

    	public String toString()
    	{
        	return _uri;
    	}//toString

    	public void setBlob( byte[] blob)
    	{
		_blob = blob;
    	}//setBlob

    	public byte[] getBlob()
    	{
		return _blob;
    	}//getBlob

    	public Collection getNames()
    	{
        	return _names;
    	}//getNames

    	public void setNames( Collection names)
    	{
     		_names = names;
    	}//setNames

    	public Collection getSubjects()
    	{
        	return _subjects;
    	}//getSubjects

    	public void setSubjects( Collection subjects)
    	{
		_subjects = subjects;
    	}//setSubjects

    	public Collection getWebOnts()
    	{
        	return _webonts;
    	}//getWebOnts

    	public void setWebOnts( Collection webonts)
    	{
		_webonts = webonts;
    	}//setWebOnts

    	public Collection getRdfs()
    	{
        	return _rdfs;
    	}//getRdfs

    	public void setRdfs( Collection rdfs )
    	{
		_rdfs = rdfs;
    	}//setRdfs

    	public void jdoPersistent( Database db )
    	{
        	_db = db;
    	}//jdoPersistent

    	public void jdoTransient()
    	{
        	_db = null;
    	}//jdoTransient

    	public Class jdoLoad(short accessMode)
    	{
		return Resource.class;
    	}//jdoLoad

	public void jdoBeforeCreate( Database db )
    	{
        	_creationTime = new Date();
    	}//jdoBeforeCreate

    	public void jdoAfterCreate()
    	{
    	}//jdoAfterCreate

    	public void jdoStore(boolean modified)
    	{
       		if ( modified )
            		_modificationTime = new Date();
    	}//jdoStore

    	public void jdoBeforeRemove()
    	{
    	}//jdoBeforeRemove

    	public void jdoAfterRemove()
    	{
    	}//jdoAfterRemove

    	public void jdoUpdate()
    	{
    	}//jdoUpdate

    	public void setCreationTime( Date creationTime )
    	{
        	_creationTime = creationTime;
    	}//setCreationTime

    	public Date getCreationTime()
    	{
        	return _creationTime;
    	}//getCreationTime

    	public void setModificationTime( Date modificationTime )
    	{
        	_modificationTime = modificationTime;
    	}//setModificationTime

    	public Date getModificationTime()
    	{
        	return _modificationTime;
    	}//getModificationTime

    	public long jdoGetTimeStamp()
    	{
        	return _timeStamp;
    	}//jdoGetTimeStamp

    	public void jdoSetTimeStamp( long timeStamp )
    	{
        	_timeStamp = timeStamp;
    	}//jdoSetTimeStamp

}//Resource

