/*
 * Subdivs.java - load representation of Subdiv authorities object.
 *
 * 		Art Rhyno (arhyno@uwindsor.ca), Aug. 2002
 *		(c) Copyright GNU General Public License (GPL)
 *
 * 		Revised:
 *
 */

//PYTHEAS
package pytheas;

//Standard
import java.util.Date;
import java.util.Collection;
import java.util.Enumeration;

//Castor
import org.exolab.castor.jdo.Database;
import org.exolab.castor.jdo.Persistent;
import org.exolab.castor.jdo.TimeStampable;

public class Subdivs implements Persistent, TimeStampable
{

	private int		_id;

	private Authority	_authority;

	private Database 	_db;

	private Collection   	_subjects;

	private String   	_subdiv;

	private String   	_type;

	private String   	_uri;

	private Date		_creationTime;

	private Date     	_modificationTime;

	private long     	_timeStamp;

	public int getId()
	{
        	return _id;
    	}//getId

	public void setId( int id )
    	{
        	_id = id;
    	}//setId

	public Authority getAuthority()
    	{
        	return _authority;
    	}//getAuthority

	public void setAuthority( Authority authority )
    	{
        	_authority = authority;
    	}//setAuthority
    
	public String getSubdiv()
    	{
        	return _subdiv;
    	}//getSubdiv

	public void setSubdiv( String subdiv )
	{
        	_subdiv = subdiv;
    	}//setSubdiv

	public String getType()
	{
		return _type;
	}//getType

	public void setType( String type )
	{
        	_type = type;
    	}//setType

	public String getUri()
	{
		return _uri;
	}//getUri

	public void setUri( String uri )
    	{
        	_uri = uri;
    	}//setUri

	public Collection getSubjects()
    	{
        	return _subjects;
    	}//getSubjects

	public void setSubjects( Collection subjects)
    	{
		_subjects = subjects;
    	}//setSubjects

    	public String toString()
    	{
        	return _subdiv;
    	}//toString

    	public void jdoPersistent( Database db )
    	{
        	_db = db;
    	}//jdoPersistent

    	public void jdoTransient()
    	{
        	_db = null;
    	}//jdoTransient

    	public Class jdoLoad(short accessMode)
    	{
		return Subdivs.class;
    	}//jdoLoad

    	public void jdoBeforeCreate( Database db )
    	{
        	_creationTime = new Date();
    	}//jdoBeforeCreate

    	public void jdoAfterCreate()
    	{
    	}//jdoAfterCreate

    	public void jdoStore(boolean modified)
    	{
       		if ( modified )
            		_modificationTime = new Date();
    	}//jdoStore

    	public void jdoBeforeRemove()
    	{
    	}//jdoBeforeRemove

    	public void jdoAfterRemove()
    	{
    	}//jdoAfterRemove

    	public void jdoUpdate()
    	{
    	}//jdoUpdate

    	public void setCreationTime( Date creationTime )
    	{
        	_creationTime = creationTime;
    	}//setCreationTime

    	public Date getCreationTime()
    	{
        	return _creationTime;
    	}//getCreationTime

    	public void setModificationTime( Date modificationTime )
    	{
        	_modificationTime = modificationTime;
    	}//setModificationTime

    	public Date getModificationTime()
    	{
        	return _modificationTime;
    	}//getModificationTime

    	public long jdoGetTimeStamp()
    	{
        	return _timeStamp;
    	}//jdoGetTimeStamp

    	public void jdoSetTimeStamp( long timeStamp )
    	{
        	_timeStamp = timeStamp;
    	}//jdoSetTimeStamp
}//Subdivs

