/*
 * Subjects.java - load representation of Subjects object.
 *
 * 		Art Rhyno (arhyno@uwindsor.ca), Sept. 2001
 *		(c) Copyright GNU General Public License (GPL)
 *
 * 		Revised:
 *			Aug. 2002 - added MARC & subdivision links
 *
 */

//PYTHEAS
package pytheas;

//Standard
import java.util.Date;
import java.util.Collection;
import java.util.Enumeration;

//Castor
import org.exolab.castor.jdo.Database;
import org.exolab.castor.jdo.Persistent;
import org.exolab.castor.jdo.TimeStampable;

public class Subjects implements Persistent, TimeStampable
{

	private int		_id;

	private Authority	_authority;

	private Database 	_db;

    	private Collection	_resources;

	private Collection   	_subdivs;

    	private String   	_subject;

    	private String   	_type;

    	private String   	_uri;

    	private boolean 	_isCrossref;

    	private boolean 	_isEstablished;

    	private Date     	_creationTime;

    	private Date     	_modificationTime;

    	private long     	_timeStamp;

	public int getId()
	{
        	return _id;
    	}//getId

	public void setId( int id )
	{
        	_id = id;
	}//setId

	public Authority getAuthority()
    	{
        	return _authority;
    	}//getAuthority

    	public void setAuthority( Authority authority )
    	{
        	_authority = authority;
    	}//setAuthority
    
    	public String getSubject()
    	{
        	return _subject;
    	}//getSubject

    	public void setSubject( String subject )
    	{
        	_subject = subject;
    	}//setSubject

    	public String getType()
    	{
        	return _type;
    	}//getType

    	public void setType( String type )
    	{
        	_type = type;
    	}//setType

    	public String getUri()
    	{
        	return _uri;
    	}//getUri

    	public void setUri( String uri )
    	{
        	_uri = uri;
    	}//setUri

    	public boolean getIsCrossref()
    	{
        	return _isCrossref;
    	}//getIsCrossref

    	public void setIsCrossref( boolean isCrossref )
    	{
        	_isCrossref = isCrossref;
    	}//setIsCrossref

	public boolean getIsEstablished()
	{
		return _isEstablished;
	}//getIsEstablished

	public void setIsEstablished( boolean isEstablished )
	{
		_isEstablished = isEstablished;
	}//setIsEstablished

	public Collection getResources()
	{
		return _resources;
	}//getResources

	public void setResources( Collection resources)
	{
		_resources = resources;
    	}//setResources

	public Collection getSubdivs()
	{
		return _subdivs;
	}//getSubdivs

	public void setSubdivs( Collection subdivs)
	{
		_subdivs = subdivs;
	}//setSubdivs

	public String toString()
	{
        	return _subject;
    	}//toString

	public void jdoPersistent( Database db )
	{
        	_db = db;
	}//jdoPersistent

	public void jdoTransient()
	{
        	_db = null;
    	}//jdoTransient

    	public Class jdoLoad(short accessMode)
    	{
		return Subjects.class;
    	}//jdoLoad

	public void jdoBeforeCreate( Database db )
    	{
        	_creationTime = new Date();
    	}//jdoBeforeCreate

	public void jdoAfterCreate()
	{
    	}//jdoAfterCreate

	public void jdoStore(boolean modified)
    	{
       		if ( modified )
            		_modificationTime = new Date();
    	}//jdoStore

	public void jdoBeforeRemove()
    	{
    	}//jdoBeforeRemove

	public void jdoAfterRemove()
	{
    	}//jdoAfterRemove

	public void jdoUpdate()
    	{
    	}//jdoUpdate

	public void setCreationTime( Date creationTime )
    	{
        	_creationTime = creationTime;
    	}//setCreationTime

	public Date getCreationTime()
    	{
        	return _creationTime;
    	}//getCreationTime

    	public void setModificationTime( Date modificationTime )
    	{
        	_modificationTime = modificationTime;
    	}//setModificationTime

    	public Date getModificationTime()
    	{
        	return _modificationTime;
    	}//getModificationTime

    	public long jdoGetTimeStamp()
    	{
        	return _timeStamp;
    	}//jdoGetTimeStamp

    	public void jdoSetTimeStamp( long timeStamp )
    	{
        	_timeStamp = timeStamp;
    	}//jdoSetTimeStamp
}//Subjects

