/*
 * Topic.java - load representation of topic object.
 *
 * 		Art Rhyno (arhyno@uwindsor.ca), Sept. 2002
 *		(c) Copyright GNU General Public License (GPL)
 *
 * 		Revised:
 *
 */

//PYTHEAS
package pytheas;

//Standard
import java.util.Collection;
import java.util.Date;
import java.util.Vector;
import java.util.Enumeration;

//Castor
import org.exolab.castor.jdo.Database;
import org.exolab.castor.jdo.Persistent;
import org.exolab.castor.jdo.TimeStampable;

public class Topic implements Persistent, TimeStampable
{

	private int		_id;

	private String		_topicIdent;

	private int		_subjectIdentRef;

	private int		_resourceRef;

	private String		_resourceData;

	private boolean 	_isInstance;

	private boolean 	_isPublished;

	private boolean 	_isMember;

	private boolean 	_isOccurance;

	private boolean 	_isRole;

	private Topicmap 	_topicMap;

	private Collection 	_idents;

	private Collection 	_basenames;

	private Collection 	_scopes;

	private Collection 	_associations;

	private Database     	_db;

	private Date     	_creationTime;

	private Date     	_modificationTime;

	private long     	_timeStamp;


    	public int getId()
    	{
        	return _id;
    	}//getId

    	public void setId( int id )
    	{
        	_id = id;
    	}//setId

    	public String getTopicIdent()
    	{
        	return _topicIdent;
    	}//getTopicIdent

    	public void setTopicIdent( String topicIdent )
    	{
        	_topicIdent = topicIdent;
    	}//setTopicIdent

	public int getSubjectIdentRef()
	{
        	return _subjectIdentRef;
    	}//getSubjectIdentRef

	public void setSubjectIdentRef( int subjectIdentRef )
    	{
        	_subjectIdentRef = subjectIdentRef;
    	}//setSubjectIdentRef

	public int getResourceRef()
	{
        	return _resourceRef;
    	}//getResourceRef

	public void setResourceRef( int resourceRef )
    	{
        	_resourceRef = resourceRef;
    	}//setResourceRef

	public String getResourceData()
	{
        	return _resourceData;
    	}//getResourceData

	public void setResourceData( String resourceData )
	{
        	_resourceData = resourceData;
	}//setResourceData

	public boolean getIsInstance()
    	{
        	return _isInstance;
    	}//getIsInstance

	public void setIsInstance( boolean isInstance )
    	{
        	_isInstance = isInstance;
    	}//setIsInstance

	public boolean getIsPublished()
	{
        	return _isPublished;
    	}//getIsPublished

	public void setIsPublished( boolean isPublished )
	{
		_isPublished = isPublished;
	}//setIsPublished

	public boolean getIsMember()
	{
        	return _isMember;
    	}//getIsMember

	public void setIsMember( boolean isMember )
    	{
        	_isMember = isMember;
    	}//setIsMember

	public boolean getIsOccurance()
	{
		return _isOccurance;
	}//getIsOccurance

	public void setIsOccurance( boolean isOccurance )
	{
		_isOccurance = isOccurance;
    	}//setIsOccurance

	public boolean getIsRole()
	{
        	return _isRole;
    	}//getIsRole

	public void setIsRole( boolean isRole )
    	{
        	_isRole = isRole;
    	}//setIsRole

	public Topicmap getTopicMap()
	{
        	return _topicMap;
    	}//getTopicMap

    	public void setTopicMap ( Topicmap topicMap )
    	{
        	_topicMap = topicMap;
    	}//setTopicMap

    	public Collection getIdents()
    	{
        	return _idents;
    	}//getIdents

    	public void setIdents( Collection idents )
    	{
		_idents = idents;
    	}//setIdents

    	public Collection getBasenames()
    	{
        	return _basenames;
    	}//getBasenames

    	public void setBasenames( Collection basenames )
    	{
		_basenames = basenames;
    	}//setBasenames

    	public Collection getScopes()
    	{
        	return _scopes;
    	}//getScopes

    	public void setScopes( Collection scopes )
    	{
		_scopes = scopes;
    	}//setScopes

    	public Collection getAssociations()
    	{
        	return _associations;
    	}//getAssociations

    	public void setAssociations( Collection associations )
    	{
		_associations = associations;
    	}//setAssociations

    	public void jdoPersistent( Database db )
    	{
        	_db = db;
    	}//jdoPersistent

    	public void jdoTransient()
    	{
        	_db = null;
    	}//jdoTransient

	public Class jdoLoad(short accessMode)
    	{
        	return Topic.class;
    	}//jdoLoad

	public void jdoBeforeCreate( Database db )
	{
		_creationTime = new Date();
    	}//jdoBeforeCreate

	public void jdoAfterCreate()
	{
    	}//jdoAfterCreate

	public void jdoStore(boolean modified)
	{
        	if ( modified )
            		_modificationTime = new Date();
    	}//jdoStore

	public void jdoBeforeRemove()
	{
    	}//jdoBeforeRemove

	public void jdoAfterRemove()
	{
    	}//jdoAfterRemove

	public void jdoUpdate()
	{
	}//jdoUpdate

	public String toString()
	{
        	return _topicIdent;
	}//toString

	public void setCreationTime( Date creationTime )
	{
        	_creationTime = creationTime;
	}//setCreationTime

	public Date getCreationTime()
	{
		return _creationTime;
    	}//getCreationTime

	public void setModificationTime( Date modificationTime )
	{
        	_modificationTime = modificationTime;
	}//setModificationTime

	public Date getModificationTime()
	{
        	return _modificationTime;
    	}//getModificationTime

    	public long jdoGetTimeStamp()
    	{
        	return _timeStamp;
    	}//jdoGetTimeStamp

	public void jdoSetTimeStamp( long timeStamp )
	{
        	_timeStamp = timeStamp;
    	}//jdoSetTimeStamp
}//Topic
