/*
 * Topicmap.java - load representation of topic object.
 *
 * 		Art Rhyno (arhyno@uwindsor.ca), Sept. 2002
 *		(c) Copyright GNU General Public License (GPL)
 *
 * 		Revised:
 *
 */

//PYTHEAS
package pytheas;


//Standard Java
import java.util.Date;
import java.util.Collection;
import java.util.Enumeration;

//Castor
import org.exolab.castor.jdo.Database;
import org.exolab.castor.jdo.Persistent;
import org.exolab.castor.jdo.TimeStampable;

public class Topicmap implements Persistent, TimeStampable
{

	private int		_id;

	private Database  	_db;

	private String    	_topicMapIdent;

	private String    	_nameSpace;

	private String    	_xlink;

	private String    	_xmlbase;

	private Collection 	_topics;

	private Date     	_creationTime;

    	private Date     	_modificationTime;

    	private long     	_timeStamp;

    	public int getId()
    	{
        	return _id;
    	}//getId

    	public void setId( int id )
    	{
        	_id = id;
    	}//setId

    	public String getNameSpace()
    	{
        	return _nameSpace;
    	}//getNameSpace

    	public void setNameSpace( String nameSpace )
    	{
        	_nameSpace = nameSpace;
    	}//setNameSpace

    	public String getTopicMapIdent()
    	{
        	return _topicMapIdent;
    	}//getTopicMapIdent

    	public void setTopicMapIdent( String topicMapIdent )
    	{
        	_topicMapIdent = topicMapIdent;
    	}//setTopicMapIdent

    	public String getXlink()
    	{
        	return _xlink;
    	}//getXlink

    	public void setXlink( String xlink )
    	{
        	_xlink = xlink;
    	}//setXlink

    	public String getXmlbase()
    	{
        	return _xmlbase;
    	}//getXmlbase

    	public void setXmlbase( String xmlbase )
    	{
        	_xmlbase = xmlbase;
    	}//setXmlbase

    	public Collection getTopics()
    	{
        	return _topics;
    	}//getTopics

    	public void setTopics( Collection topics )
    	{
		_topics = topics;
    	}//setTopics

    	public void jdoPersistent( Database db )
    	{
        	_db = db;
    	}//jdoPersistent

    	public void jdoTransient()
    	{
        	_db = null;
    	}//jdoTransient

    	public Class jdoLoad(short accessMode)
    	{
		return Topicmap.class;
    	}//jdoLoad

    	public void jdoBeforeCreate( Database db )
    	{
        	_creationTime = new Date();
    	}//jdoBeforeCreate

    	public void jdoAfterCreate()
    	{
    	}//jdoAfterCreate

	public void jdoStore(boolean modified)
    	{
       		if ( modified )
            		_modificationTime = new Date();
    	}//jdoStore

    	public void jdoBeforeRemove()
    	{
    	}//jdoBeforeRemove

    	public void jdoAfterRemove()
    	{
    	}//jdoAfterRemove

    	public void jdoUpdate()
    	{
    	}//jdoUpdate

    	public void setCreationTime( Date creationTime )
    	{
        	_creationTime = creationTime;
    	}//setCreationTime

    	public Date getCreationTime()
    	{
        	return _creationTime;
    	}//getCreationTime

    	public void setModificationTime( Date modificationTime )
    	{
        	_modificationTime = modificationTime;
    	}//setModificationTime

    	public Date getModificationTime()
    	{
        	return _modificationTime;
    	}//getModificationTime

    	public long jdoGetTimeStamp()
    	{
        	return _timeStamp;
    	}//jdoGetTimeStamp

    	public void jdoSetTimeStamp( long timeStamp )
    	{
        	_timeStamp = timeStamp;
    	}//jdoSetTimeStamp
}//Topicmap

