/*
 * Variant.java - load representation of variant object for Topic Map.
 *
 * 		Art Rhyno (arhyno@uwindsor.ca), Sept. 2002
 *		(c) Copyright GNU General Public License (GPL)
 *
 * 		Revised:
 *
 */


//PYTHEAS
package pytheas;


//Standard
import java.util.Date;
import java.util.Collection;
import java.util.Enumeration;

//Castor
import org.exolab.castor.jdo.Database;
import org.exolab.castor.jdo.Persistent;
import org.exolab.castor.jdo.TimeStampable;

public class Variant implements Persistent, TimeStampable
{

	private int		_id;

	private Database  	_db;

	private String		_variantName;

	private Basename 	_basename;

	private Collection 	_parms;

	private Collection 	_scopes;

	private Date     	_creationTime;

	private Date     	_modificationTime;

	private long     	_timeStamp;

    	public int getId()
    	{
        	return _id;
    	}

    public void setId( int id )
    {
        _id = id;
    }

    public String getVariantName()
    {
        return _variantName;
    }

    public void setVariantName( String variantName )
    {
        _variantName = variantName;
    }

    public Basename getBasename()
    {
        return _basename;
    }

    public void setBasename( Basename basename )
    {
        _basename = basename;
    }

    public Collection getParms()
    {
        return _parms;
    }

    public void setParms( Collection parms)
    {
        _parms = parms;
    }

    public Collection getScopes()
    {
        return _scopes;
    }

    public void setScopes( Collection scopes)
    {
        _scopes = scopes;
    }

    public void jdoPersistent( Database db )
    {
        _db = db;
    }

    public void jdoTransient()
    {
        _db = null;
    }

    public Class jdoLoad(short accessMode)
    {
	return Resource.class;
    }

    public void jdoBeforeCreate( Database db )
    {
        _creationTime = new Date();
    }

    public void jdoAfterCreate()
    {
    }

    public void jdoStore(boolean modified)
    {
       if ( modified )
            _modificationTime = new Date();

    }

    public void jdoBeforeRemove()
    {
    }

    public void jdoAfterRemove()
    {
    }

    public void jdoUpdate()
    {
    }

    public void setCreationTime( Date creationTime )
    {
        _creationTime = creationTime;
    }


    public Date getCreationTime()
    {
        return _creationTime;
    }


    public void setModificationTime( Date modificationTime )
    {
        _modificationTime = modificationTime;
    }


    public Date getModificationTime()
    {
        return _modificationTime;
    }

    public long jdoGetTimeStamp()
    {
        return _timeStamp;
    }


    public void jdoSetTimeStamp( long timeStamp )
    {
        _timeStamp = timeStamp;
    }

}
