/*
 * WebOnt.java - load representation of WebOnt object for Resources.
 *
 * 		Art Rhyno (arhyno@uwindsor.ca), Sept. 2002
 *		(c) Copyright GNU General Public License (GPL)
 *
 * 		Revised:
 *
 */


//PYTHEAS
package pytheas;

//Standard Java
import java.util.Date;
import java.util.Collection;
import java.util.Enumeration;

//Castor
import org.exolab.castor.jdo.Database;
import org.exolab.castor.jdo.Persistent;
import org.exolab.castor.jdo.TimeStampable;

public class WebOnt implements Persistent, TimeStampable
{

	private int      	_id;

    	private Database 	_db;

    	private Collection  	_resources;

    	private String   	_nameSpace;

    	private String   	_className;

    	private String   	_classType;

    	private String   	_label;

    	private String   	_comment;
	
    	private String   	_ontCode;

    	private String   	_ontValue;

    	private int      	_resource;

    	private Date     	_creationTime;

    	private Date     	_modificationTime;

    	private long     	_timeStamp;

    	public int getId()
    	{
        	return _id;
    	}//getId

    	public void setId( int id )
    	{
        	_id = id;
    	}//setId
    
    	public String getNameSpace()
    	{
        	return _nameSpace;
    	}//getNameSpace

    	public void setNameSpace( String nameSpace )
    	{
        	_nameSpace = nameSpace;
    	}//setNameSpace

	public String getClassName()
    	{
        	return _className;
    	}//getClassName

    	public void setClassName( String className )
    	{
        	_className = className;
    	}//setClassName

    	public String getClassType()
    	{
        	return _classType;
    	}//getClassType

    	public void setClassType( String classType )
    	{
        	_classType = classType;
    	}//setClassType

	public String getLabel()
    	{
        	return _label;
    	}//getLabel

	public void setLabel( String label )
    	{
        	_label = label;
    	}//setLabel

	public String getComment()
    	{
        	return _comment;
    	}//getComment

    	public void setComment( String comment )
    	{
        	_comment = comment;
    	}//setComment

	public String getOntCode()
    	{
        	return _ontCode;
    	}//getOntCode

    	public void setOntCode ( String ontCode )
    	{
        	_ontCode = ontCode;
    	}//setOntCode

    	public String getOntValue()
    	{
        	return _ontValue;
    	}//getOntValue

    	public void setOntValue ( String ontValue )
    	{
        	_ontValue = ontValue;
    	}//setOntValue

    	public void setResource( int resource )
    	{
        	_resource = resource;
    	}//setResource

    	public int getResource()
    	{
        	return _resource;
    	}//getResource

    	public void setResources( Collection resources )
    	{
        	_resources = resources;
    	}//setResources

    	public Collection getResources()
    	{
        	return _resources;
    	}//getResources

    	public String toString()
    	{
        	return _ontValue;
    	}//toString

    	public void jdoPersistent( Database db )
    	{
        	_db = db;
    	}//jdoPersistent

    	public void jdoTransient()
    	{
        	_db = null;
    	}//jdoTransient

    	public Class jdoLoad(short accessMode)
    	{
		return WebOnt.class;
    	}//jdoLoad

    	public void jdoBeforeCreate( Database db )
    	{
        	_creationTime = new Date();
    	}//jdoBeforeCreate

    	public void jdoAfterCreate()
    	{
    	}//jdoAfterCreate

    	public void jdoStore(boolean modified)
    	{
       		if ( modified )
            		_modificationTime = new Date();
    	}//jdoStore

    	public void jdoBeforeRemove()
    	{
    	}//jdoBeforeRemove

    	public void jdoAfterRemove()
    	{
    	}//jdoAfterRemove

    	public void jdoUpdate()
    	{
    	}//jdoUpdate

    	public void setCreationTime( Date creationTime )
    	{
        	_creationTime = creationTime;
    	}//setCreationTime

    	public Date getCreationTime()
    	{
        	return _creationTime;
    	}//getCreationTime

    	public void setModificationTime( Date modificationTime )
    	{
        	_modificationTime = modificationTime;
    	}//setModificationTime

    	public Date getModificationTime()
    	{
        	return _modificationTime;
    	}//getModificationTime

    	public long jdoGetTimeStamp()
    	{
        	return _timeStamp;
    	}//jdoGetTimeStamp

    	public void jdoSetTimeStamp( long timeStamp )
    	{
        	_timeStamp = timeStamp;
    	}//jdoSetTimeStamp
}//WebOnt

