/*
 * FormInfo - provide simple Form processing.
 *
 *		This assumes a particular structure for a Form with
 *		a boolean list at the end of any section that needs
 *		to be repeated. A much better way of doing this would
 *		be to use the DOM but it didn't occur to me at the
 *		time (-: Also, the Java Form processing API is a
 *		good tool for Form validation, definitely worth looking
 *		into. 
 *
 * 		Art Rhyno (arhyno@uwindsor.ca), Mar. 2002
 *		(c) Copyright GNU General Public License (GPL)
 *
 */

package pyserv;

//PYTHEAS Classes
import pytheas.*;

//Google API
import com.google.soap.search.*;

//Standard Java
import java.net.*;
import java.io.*;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringReader;
import java.util.Date;
import java.util.StringTokenizer;
import java.util.Vector;
import java.util.Enumeration;

//Servlet
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

//Apache
import org.apache.xml.serialize.*;

//SAX
import org.xml.sax.InputSource;
import org.xml.sax.helpers.AttributeListImpl;


public class FormInfo
    extends XMLServlet
{


	String theInfo = "";
   	int typeRDF = 0;
	int typeMARC = 1;
	int typeOBJ = 3;
	String tempOPT = " tempOpt ";
	String nameCode="DC\" OR nameCode=\"BIB1";

	/*
		pullOutInfo - work though HTML form

		We don't want to have to specify every web element, so we pull them from
		the form itself. This has the advantage of making these functions somewhat
		generic but the form needs to have all its repeatable sections on one line
		and include an element called boolean. 
	*/
	FormInfo(HttpServletRequest request, boolean expandHTML,
		int theType, XMLServletResponse response,  
		String focus, String rdfHTML, String marcHTML, boolean useGoogle,
		Vector termSugs, String googleKey) throws IOException, ServletException
	{
		int outCnt = 0;
		int curVar = 0;

		String partOfInput = "";
		String theVar = "";
		String theValue = "";
		String incVar = "";
		String oldVar = "none";

		int varIndex = 0;

		String newLine = "";
		String htmlFile = "";
		
		StringTokenizer tokens;
		String valueInd = "name=\"";
		String input;

		int thisPosition = 0;
		int startAt = 0;
		String thisPiece = "";


		PrintWriter out = response.getWriter();

		Vector allHTMLlines = new Vector();
		Vector newHTMLlines = new Vector();

		if (theType == typeRDF)
			htmlFile = rdfHTML;
		else if (theType == typeMARC)
			htmlFile = marcHTML;

		URL theURL = new URL(htmlFile);

		BufferedReader In1 = new BufferedReader(new InputStreamReader(theURL.openStream())); 

		if (expandHTML)
			out = response.getWriter();
    
		while ((input = In1.readLine()) != null) 
			allHTMLlines.addElement(input);
		In1.close();

		for (int i=0; i<allHTMLlines.size();i++) {
			input = (String) allHTMLlines.elementAt(i);

			//make the latest part of the form the default focus
			if (input.indexOf(".focus()") != -1) {
				input = searchReplace(input,".focus()",
					focus + ".focus()");
			}//if

			newHTMLlines.addElement(input);
			outCnt = newHTMLlines.size() - 1;
			newLine = input;
			thisPosition = newLine.indexOf(valueInd);
			startAt = 0;
			while (thisPosition != -1 && theVar.indexOf("endVars") == -1) {
				thisPosition = thisPosition + valueInd.length();
				partOfInput = newLine.substring(thisPosition);
				thisPiece = newLine.substring(startAt,thisPosition);
	    			tokens = new StringTokenizer(partOfInput,"\"");
				theValue = "";
				if (tokens.hasMoreTokens()) {
					theVar = tokens.nextToken().trim();
					while (theVar.indexOf("endVars") == -1 && theValue != null) {
						if (theVar.indexOf(oldVar) == -1) 
							curVar = 0;

						if (curVar == 0 && theValue.length()==0) {
							oldVar = theVar;
							incVar = theVar;
							theValue = request.getParameter(theVar).trim();
						} else {
							String test = theVar + "_" + (curVar - 1);
							// check to see if values skipped
							if (incVar.indexOf(test) == -1 && curVar > 0) 
								curVar--;
							incVar = theVar + "_" + curVar++;
							theValue = request.getParameter(incVar);
						}//if curVar

						if (theVar.equals("nameCode") && !expandHTML && theValue==null) { 
							if (theInfo.indexOf("nameCode") == -1) {
								theValue = nameCode;
								System.out.println("add " + nameCode);
							}//if theInfo
						}//if theVar

						if (theValue != null) {
							if (theValue.indexOf("*") == 0 || theValue.length() == 0) {
									curVar++;
							} else {
								if (!expandHTML) {
									if (theVar.indexOf("requestType") == -1)
										theInfo = buildQuery(
											theVar,incVar,curVar,theValue,theInfo,
											theType,useGoogle,termSugs,googleKey);
								} else {
									cycleThruHTML(newHTMLlines,theValue,
										thisPiece,theVar,incVar,curVar,
										outCnt - 1,input);
								} //if !expandHTML
							} //if theValue
						} // if theValue != null
						if (theValue != null)
							if (theVar.equals("nameCode") && !expandHTML && theValue.indexOf(nameCode) != -1) 
								theValue = null;
					}//while theVar
				}//if tokens

				startAt = thisPosition;
				thisPosition = partOfInput.indexOf(valueInd);
				if (thisPosition != -1)
					thisPosition = thisPosition + startAt;
				else
					startAt = 0;
			}//while thisPosition
		}//for allHTMLlines

		if (expandHTML) 
			printOutFrag(out,0,newHTMLlines.size() - 1,newHTMLlines);
		else {
			if (theInfo.toString().indexOf(tempOPT) != -1)
				theInfo = searchReplaceAll(theInfo.toString(),tempOPT," AND ");
		}//if expandHTML
	}//pullOutInfo

    	public void service( HttpServletRequest request, XMLServletResponse response)
        	throws IOException,ServletException
    	{
		// need this to extend XMLServlet
	}//service

	public void cycleThruHTML(Vector newHTMLlines, String theValue, String thisPiece, 
		String theVar, String incVar, int curVar, int outCnt, String origLine)
	{
		
		int theSpot = 0;
		int varIndex = 0;
		String input = "";
		boolean changeSelect = false;
		int thisVar = 0;


		Vector optionVals = new Vector();
		optionVals.addElement("nameCode");
		optionVals.addElement("predicate");

		String newLine = (String) newHTMLlines.elementAt(newHTMLlines.size() - 1);

		theSpot = getIndex(newHTMLlines,incVar,outCnt);

		if (theSpot == 0) {
			input = incrementVarCnt(origLine,theVar,curVar,newHTMLlines,
				"<!-- DEBUG " + " curVar: " + curVar,
				incVar,optionVals);
		} else
			input = (String) newHTMLlines.elementAt(theSpot);

		if (input.indexOf("boolean") != -1) {
			String test = (String) newHTMLlines.elementAt(newHTMLlines.size() - 1);
			int pos = test.indexOf("_");
			if (pos > -1) 
				thisVar = Integer.parseInt(test.substring(pos + 1,pos + test.substring(pos).indexOf("\"")));

			while (thisVar <= curVar) {
				if (getIndex(newHTMLlines,theVar + "_" + thisVar,outCnt) == 0) 
					newHTMLlines.addElement(incrementVarCnt(origLine,theVar,thisVar + 1,newHTMLlines,
					"<!-- DEBUG " + " curVar: " + curVar,
					incVar,optionVals));
				thisVar++;
			}//while
		}

		varIndex = thisPiece.indexOf("<select");
		 
		if (varIndex != -1) {
			input = searchReplace(input,
				"name=\"" +
				incVar +
				"\"><option value=\"\" " +
				"selected",
				"name=\"" +
				incVar +
				"\"><option value=\"\"");
			changeSelect = true;
		}//if

		varIndex = thisPiece.indexOf("<textarea");
		if (varIndex != -1) {
			input = searchReplace(
				input,
				"</textarea",
				theValue + "</textarea");										
			varIndex = -1;
		} else
			varIndex = thisPiece.indexOf("name=");

		if (varIndex != -1) {
			input = workWithValues(changeSelect,"value=\"" + theValue + "\"",input,incVar,
					theValue,theVar);
		} // if varIndex

		theSpot = getIndex(newHTMLlines,incVar,outCnt);

		if (input.length() > 0) {
			if (theSpot == 0) {
				newHTMLlines.addElement(input);
			} else {
				String see = (String) newHTMLlines.elementAt(theSpot);
				/*
				if (theVar.indexOf("boolean") == -1)
				System.out.println("changing at " + theSpot +
					" for\n " + see + "with\n" + input + " - " + incVar);
				*/
				newHTMLlines.removeElementAt(theSpot);
				newHTMLlines.insertElementAt(input,theSpot);
			}//if theSpot
		}//if
	}//cycleThruHTML

	public int getIndex(Vector newHTMLlines,String incVar,int outCnt)
	{
		String test="";
		for (int i=outCnt; i<newHTMLlines.size();i++) {
			test = (String) newHTMLlines.elementAt(i);
			if (test.indexOf(incVar) != -1) {
				// System.out.println("returning " + i);
				return i;
			}//if
		}//for
		return 0;

	}//getIndex

	public String buildQuery(String theVar,String incVar, int curVar, String theValue,String theQuery,
		int theType, boolean useGoogle, Vector termSugs,String googleKey) throws ServletException
	{	
		String thePrefix = "";	
		String theCode = "nameCode";
		boolean isNameCode = false;
		if (theValue.indexOf("nameCode") != -1 || theVar.indexOf("nameCode") != -1)
			isNameCode = true;
		int namePos = theQuery.indexOf(theCode);
		int thisPos = namePos;
		String nameStr = theQuery;
		while (nameStr.indexOf(theCode) != -1) {
			nameStr = nameStr.substring(
				thisPos + theCode.length());
				thisPos = nameStr.indexOf(theCode);
		}//while

		/*
		System.out.println("nameStr is " + nameStr + " and " +
			theQuery + " amd " + namePos);
		*/

		if (theType == typeRDF)
			thePrefix = "select r from pytheas.Rdf r where ";
		else if (theType == typeMARC)
			thePrefix = "select b from pytheas.Bib b where ";
	
		String right = "\"";
		String left = "\"";

		if (!isNameCode) {
			termSugs.addElement(new TermInfo(theValue,theVar,"",
				false,false));
			if (useGoogle) {
				String googleSuggests = googleSuggests(theValue,googleKey);
				if (googleSuggests != null) {
					if (googleSuggests.length() > 0)
						termSugs.addElement(new TermInfo(theValue,theVar,
							googleSuggests,true,false));
				}//if googleSugs
			}//if useGoogle 
		}//if

		StringBuffer query = new StringBuffer();						
		if (theQuery.length() > 0) {
			if (theVar.indexOf("boolean") == -1) {
				query.append(theQuery);
				query.append(tempOPT);
			} else {
				query.append(searchReplace(
					theQuery,
					tempOPT,
					" " + theValue + " "));
				return query.toString();
			}//if
		} else 
			query.append(thePrefix);

		if (theVar.indexOf("subf") != -1)
			query.append("vartags.subfs.");

		if (isNameCode || (namePos != -1 && 
			nameStr.indexOf("(") == -1))
		{
			query.append("(");
		}//if isNameCode

		query.append(theVar);
		query.append(" ");

		if (theVar.indexOf("subf") != -1 || (theType == typeRDF && theVar.indexOf("normalEntry")!= -1))
		{
			query.append("like ");
			query.append(right + "%" + theValue.toUpperCase() + "%" + left);
		} else {
			query.append("=");
			query.append(right + theValue + left);
		}//if

		if (isNameCode)
			query.append(")");

		System.out.println("-> " + query.toString());
	
		return query.toString();
	}//buildQuery

	public String workWithValues(boolean changeSelect,String changeTo,String input,
		String incVar, String theValue, String theVar)
	{
		String thisLookFor = "value=\"";
		String theLine = "";
		String replaceThis = "*";
		int partOfInput = 0;
		String tmpVar = incVar;

		int thisPos = input.indexOf(incVar);
		if (thisPos == -1) {
			tmpVar = theVar;
			thisPos = input.indexOf(tmpVar);
		}//if

		String thisPart = input.substring(thisPos);
		partOfInput = thisPart.indexOf(thisLookFor);
		partOfInput += thisLookFor.length();
		
		String thisPiece = thisPart.substring(partOfInput);

	    	StringTokenizer tokens = new StringTokenizer(thisPiece,"\"");

		if (tokens.hasMoreTokens())
			replaceThis = tokens.nextToken();

		if (changeSelect) {
			theLine = searchReplace(input, changeTo,
				changeTo + " selected");
		} else {
			theLine = searchReplace(
				input,
				"name=\"" + tmpVar + "\" value=\"" + replaceThis,
				"name=\"" + tmpVar + "\" value=\"" + theValue);
		} //if changeSelect

		return theLine;
	}//workWithValues

	public String incrementVarCnt(String newLine,String theVar,int curVar, Vector newHTMLlines,
		String theMessage, String incVar, Vector optionVals) 
	{
		String theNewMessage = " -->";
		String theLine="";
		String prefix = "";
                String valueRep = "\" value";

                if (newLine.indexOf(valueRep) != -1) {
			 theLine = searchReplaceAll(
				newLine,
                	        prefix + valueRep,
                        	"_" + (curVar - 1) + valueRep);
		} else {
			theLine = newLine;
			for (int i=0; i<optionVals.size();i++) {
				valueRep = (String) optionVals.elementAt(i);
				theLine = searchReplaceAll(
					theLine,
                		        prefix + valueRep,
                        		valueRep + "_" + (curVar - 1));
			}//for
		}//if

		theLine = searchReplaceAll(
			theLine,
			prefix + "\" cols",
			"_" + (curVar - 1) + "\" cols");

		theLine = searchReplaceAll(
			theLine,
			"boolean" + prefix + "\"",
			"boolean_" + (curVar - 1) + "\"");
		theLine = theMessage + theNewMessage + theLine;


		return theLine;
	}//incrementVarCnt


	public boolean printOutFrag(PrintWriter out,int startRow, int endRow,Vector allHTMLlines)
	{
		String test = "";
		for (int i=startRow; i<=endRow; i++) {
			test = (String)allHTMLlines.elementAt(i);
			out.println(test);
		}//for i
		return true;		

	}//printOutFrag


	public String searchReplace(String origString, String startString, String replaceString)
	{
		StringBuffer newString = new StringBuffer();

		int i = origString.indexOf(startString);

		if (i != -1) {
			newString.append(origString.substring(0,i));			
			newString.append(replaceString);
			newString.append(origString.substring(i + startString.length()));
			return newString.toString();
		}//if i
		return "";
	} //searchReplace

	public String searchReplaceAll(String origString, String startString, String replaceString)
	{
		boolean lookForNames = false;
		int i=0;
		String workString = startString;
		int x= 0;

		if (workString.length() <= 0) {
			lookForNames = true;
			workString = "name=\"";
		}//if

		StringBuffer newString = new StringBuffer();
		String test = "";

		i = origString.indexOf(workString);
		int j = 0;

		while (i != -1) {
			if (lookForNames) {
				i+= workString.length();
				i+=origString.substring(i).indexOf("\"");
			}//if
			newString.append(origString.substring(j,i));
			newString.append(replaceString);
			if (lookForNames) {
				test = origString.substring(i);
			} else
				test = origString.substring(i + workString.length());

			j = i;
			if (!lookForNames)
				j += workString.length();
			i = test.indexOf(workString);
			if (i != -1)
				i = i + j;
		}//if i

		newString.append(test);

		return newString.toString();
	}//searchReplaceAll

	public String googleSuggests(String terms, String googleKey) throws ServletException
	{
		String googleTerms = "";
		/*
		System.out.println("google checking for " + terms);
		System.out.println("key " + googleKey);
		*/

		try {
			GoogleSearch search = new GoogleSearch();
			search.setKey(googleKey);
		 	googleTerms = search.doSpellingSuggestion(terms);
		} catch (GoogleSearchFault ex) {
			googleTerms = "problem: " + ex;
		}//try				

		return googleTerms;
	}//googleSuggests

	public String toString()
	{
		return theInfo;
	}//toString
}//FormInfo
