/*
 * ReceivedMessage.java - process SOAP request.
 *
 * 		Art Rhyno (arhyno@uwindsor.ca), Sept. 2002
 *		(c) Copyright GNU General Public License (GPL)
 *
 * 		Revised:
 *
 */

//PYTHEAS
package pyserv;
import pyserv.ProcessException;

//SOAP
import javax.xml.soap.SOAPMessage;
import javax.xml.soap.SOAPPart;
import javax.xml.soap.SOAPEnvelope;
import javax.xml.soap.SOAPBody;
import javax.xml.soap.SOAPException;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.Name;

//Standard
import java.util.Iterator;

public class ReceivedMessage { 

	protected SOAPMessage soapMessage = null;

	public ReceivedMessage (SOAPMessage soapMessage) {
		this.soapMessage = soapMessage;
	}
	
	public String getRequestedName()
		throws ProcessException, SOAPException 
	{

		String resp = null;

		SOAPPart soapPart;
		SOAPEnvelope soapEnvelope;
		SOAPBody soapBody;
		Name name;

		soapPart = soapMessage.getSOAPPart();
		soapEnvelope = soapPart.getEnvelope();
		soapBody = soapEnvelope.getBody();

		name = soapEnvelope.createName(
			"GetValueByName",
			"pyns",
			"soap-example");

		Iterator valueRequests =
			soapBody.getChildElements(name);

		if (! valueRequests.hasNext()) 
			throw(new ProcessException());

		SOAPElement soapElement = 
			(SOAPElement)valueRequests.next();

		if (valueRequests.hasNext()) 
			throw(new ProcessException());

		name = soapEnvelope.createName(
			"name");

		Iterator params =
			soapElement.getChildElements(
			name);

		if (! params.hasNext()) 
			throw(new ProcessException());

		SOAPElement paramElement =
			(SOAPElement)params.next();
		resp = paramElement.getValue();

		if (null == resp) 
			throw(new ProcessException());

		return resp;
	}//getRequestedName
}//ReceivedMessage
