/*

 ReceiverServlet.java

*/
package pyserv;

import javax.xml.messaging.JAXMServlet;
import javax.xml.messaging.ReqRespListener;
import javax.xml.messaging.JAXMException;
import javax.xml.soap.MessageFactory;
import javax.xml.soap.SOAPMessage;
import javax.xml.soap.SOAPException;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import pyserv.ReceivedMessage;
import pyserv.FaultMessage;
import pyserv.ProcessException;
import pyserv.ReplyMessage;

public class ReceiverServlet
	extends JAXMServlet
	implements ReqRespListener 
{

	protected MessageFactory messageFactory = null;

	public SOAPMessage onMessage(SOAPMessage soapMsg) {

		SOAPMessage retMsg = null;
		ReceivedMessage recMsg = null;
		ReplyMessage replyMsg = null;

		String name = null;
		String theRecord = null;

		try {
			recMsg = new ReceivedMessage (soapMsg);
			name = recMsg.getRequestedName();

			// When there is more than one service,
			// theRecord(s) will be the result of a search.
			// keep simple for now
			theRecord = name;

			replyMsg = new ReplyMessage(
				messageFactory);

			replyMsg.setValue(theRecord);

			retMsg = replyMsg.getMessage();
		} catch(ProcessException e) {

			try {
				FaultMessage faultMsg =
					new FaultMessage(
					messageFactory);

				faultMsg.setFaultCode(
					"Server");
				faultMsg.setFaultString(
					"Invalid Request");
				faultMsg.setFaultDetail(
					"ProcessException");

				retMsg = faultMsg.getMessage();
			} catch(Exception ex) {
			}
		} catch (SOAPException e) {
			try {
				FaultMessage faultMsg =
					new FaultMessage(
						messageFactory);

				faultMsg.setFaultCode(
					"Server");
				faultMsg.setFaultString(
					"SOAP Exception");
				faultMsg.setFaultDetail(
					"SOAPException");

				retMsg = faultMsg.getMessage();
			} catch(Exception ex) {
			}
		} catch(Exception e) {
			try {
				FaultMessage faultMsg =
					new FaultMessage(
						messageFactory);

				faultMsg.setFaultString(
					" ");
				faultMsg.setFaultCode(
					"Server");
				faultMsg.setFaultString(
					"PYTHEAS error");

				retMsg = faultMsg.getMessage();

			} catch(Exception ex) {
			}
		} finally {
			return retMsg;
		}
	}//getRequestName

	public void init(ServletConfig servletConfig)
		throws ServletException 
	{
		System.out.println("SOAP Request...");
		super.init(servletConfig);

		// Attempt to create a new message factory.
		try {
			messageFactory =
				MessageFactory.newInstance();

		} catch(JAXMException e) {
			e.printStackTrace();
		} catch(SOAPException e) {
			e.printStackTrace();
		}
	}//init
}//ReceiverServlet
