/*
 * ReplyMessage.java - handle messages when things go wrong.
 *
 * 		Art Rhyno (arhyno@uwindsor.ca), Sept. 2002
 *		(c) Copyright GNU General Public License (GPL)
 *
 * 		Revised:
 *
 */

package pyserv;

//PYTHEAS Classes
import pytheas.*;

//SAX
import org.xml.sax.InputSource;
import org.xml.sax.helpers.AttributeListImpl;

//Castor
import org.exolab.castor.jdo.Database;
import org.exolab.castor.jdo.OQLQuery;
import org.exolab.castor.jdo.QueryResults;
import org.exolab.castor.jdo.JDO;
import org.exolab.castor.util.Logger;
import org.exolab.castor.mapping.Mapping;
import org.exolab.castor.xml.Marshaller;
import org.exolab.castor.xml.Unmarshaller;

//Standard Java
import java.io.StringWriter;

//SOAP
import javax.xml.soap.AttachmentPart;
import javax.xml.soap.MessageFactory;
import javax.xml.soap.SOAPMessage;
import javax.xml.soap.SOAPPart;
import javax.xml.soap.SOAPEnvelope;
import javax.xml.soap.SOAPBody;
import javax.xml.soap.SOAPException;
import javax.xml.soap.SOAPElement;

public class ReplyMessage {
	
	protected SOAPMessage soapMessage = null;
	public static final String fullBibFile = "/pyserv/bibfull.xml";
	public static final String DatabaseFile = "/pyserv/database.xml";

	public ReplyMessage(MessageFactory messageFactory)
		throws SOAPException 
	{
		soapMessage = messageFactory.createMessage();
	}

	public void setValue(String theRecord)
		throws SOAPException
	{
		String theResult = null;


		try {
			// the usual suspects, will need them all at some point
	     	    	JDO		jdo = null;
			Database	db = null;
	       	    	OQLQuery	oql = null;
			Object		result = null;
			Marshaller	marshal;
			Mapping 	mapping;
			QueryResults  	results;
			Bib 		bib;
			Rdf		rdf;

			StringWriter theResultIfAny = new StringWriter();

			mapping = new Mapping();
			mapping.loadMapping(fullBibFile);

			jdo = new JDO();
        		jdo.setDatabaseName( "test" );
			jdo.setConfiguration( DatabaseFile );

			db = jdo.getDatabase();
			db.begin();

			marshal = new Marshaller( theResultIfAny );
			marshal.setMapping(mapping);
			marshal.setValidation(false);

			marshal.marshal( db.load( Bib.class, new Integer(Integer.parseInt(theRecord)) ) );
			theResult = theResultIfAny.toString();

			db.commit();
			db.close();
		} catch (Exception pexcept) {
			pexcept.printStackTrace();
			throw new SOAPException(pexcept.toString());
		}//try

		SOAPPart soapPart;
		SOAPEnvelope soapEnvelope;
		SOAPBody soapBody;

		soapPart = soapMessage.getSOAPPart();
		soapEnvelope = soapPart.getEnvelope();
		soapBody = soapEnvelope.getBody();

		SOAPElement responseElement =
			soapBody.addChildElement(
			soapEnvelope.createName(
			"GetValueByNameResponse",
			"pyns",
			"soap-example"));

		SOAPElement paramElement = null;

		paramElement = responseElement.
			addChildElement("value");
	
		paramElement.addTextNode(theResult);

		AttachmentPart attachmentPart = soapMessage.createAttachmentPart();
		attachmentPart.setContent("Search Results", "text/xml");

		soapMessage.saveChanges();
	}//setValue

	public SOAPMessage getMessage() {
		return soapMessage;
	}//getMessage
}//ReplyMessage
