/*
 * TermInfo - keep information about search terms.
 *
 * 		Art Rhyno (arhyno@uwindsor.ca), Mar. 2002
 *		(c) Copyright GNU General Public License (GPL)
 *
 * 		Revised:
 *			Apr. 2002 - changed slightly for Google
 *
 */

package pyserv;

public class TermInfo
{
	String theTerm;
	String theVar;
	String theSuggestion;

	boolean isGoogle = false;
	boolean isWordNet = false;

	TermInfo(String thisTerm, String thisVar, String thisSuggestion, 
		boolean thisGoogle, boolean thisWordNet)
	{
		theTerm = thisTerm;
		theVar = thisVar;
		theSuggestion = thisSuggestion;
		isGoogle = thisGoogle;
		isWordNet = thisWordNet;
	}//pullOutInfo

	public String getTerm()
	{
		return theTerm;
	}//getTerm

	public String getVar()
	{
		return theVar;
	}//getVar

	public String getSuggestion()
	{
		return theSuggestion;
	}//getSuggestion

	public boolean fromGoogle()
	{
		return isGoogle;
	}//fromGoogle

	public boolean fromWordNet()
	{
		return isWordNet;
	}//fromWordNet

}//TermInfo
