/*
 * XMLServletResponse.java - extend standard servlet.
 *
 * 		Art Rhyno (arhyno@uwindsor.ca), Apr. 2002
 *		(c) Copyright GNU General Public License (GPL)
 *
 * 		Revised:
 *
 */

package pyserv;

import java.io.IOException;
import org.xml.sax.InputSource;
import org.xml.sax.DocumentHandler;
import org.xml.sax.SAXException;
import javax.servlet.http.HttpServletResponse;
import org.apache.xml.serialize.OutputFormat;
import org.apache.xml.serialize.Method;

public interface XMLServletResponse
	extends HttpServletResponse
{

	public DocumentHandler getDocumentHandler()
        	throws IOException, SAXException, IllegalStateException;

    	public void setStylesheet( String path )
        	throws IOException, IllegalStateException;

    	public void setStylesheet( InputSource source )
        	throws IOException, IllegalStateException;

    	public void setOutputFormat( OutputFormat format )
        	throws IllegalStateException;

    	public void setOutputMethod( String method )
        	throws IllegalStateException;
}//XMLServletResponse
