/*
 * RequestMessage.java - put together the SOAP Request.
 *
 * 		Art Rhyno (arhyno@uwindsor.ca), Sept. 2002
 *		(c) Copyright GNU General Public License (GPL)
 *
 * 		Revised:
 *
 */

package soapclient;

import javax.xml.soap.MessageFactory;
import javax.xml.soap.SOAPMessage;
import javax.xml.soap.SOAPPart;
import javax.xml.soap.SOAPEnvelope;
import javax.xml.soap.SOAPBody;
import javax.xml.soap.SOAPException;
import javax.xml.soap.SOAPElement;

public class RequestMessage {

	protected SOAPMessage soapMessage = null;

	public RequestMessage()
		throws SOAPException
	{

		MessageFactory mf = MessageFactory.newInstance();

		soapMessage = mf.createMessage();
	}//RequestMessage

	public void setName(String name)
		throws SOAPException
	{

		SOAPPart soapPart =
			soapMessage.getSOAPPart();
		SOAPEnvelope envelope =
			soapPart.getEnvelope();
		SOAPBody body =
			envelope.getBody();

		SOAPElement requestElement;
		requestElement = body.addChildElement(
			envelope.createName(
				"GetValueByName",
				"pyns",
				"soap-example"));

		SOAPElement paramElement;

		paramElement =
			requestElement.addChildElement("name");
		paramElement.addTextNode(name);
	}//setName

	public SOAPMessage getMessage() {
		return soapMessage;
	}//getMessage
}//RequestMessage