/*
 * ResponseMessage.java - deal with what comes back from request.
 *
 * 		Art Rhyno (arhyno@uwindsor.ca), Sept. 2002
 *		(c) Copyright GNU General Public License (GPL)
 *
 * 		Revised:
 *
 */
package soapclient;

import javax.xml.soap.SOAPMessage;
import javax.xml.soap.SOAPPart;
import javax.xml.soap.SOAPEnvelope;
import javax.xml.soap.SOAPBody;
import javax.xml.soap.SOAPException;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.Name;
import java.util.Iterator;
import soapclient.ProcessException;

public class ResponseMessage {

	protected SOAPMessage soapMessage = null;

	public ResponseMessage(SOAPMessage soapMessage)
	{
		this.soapMessage = soapMessage;
	}//ResponseMessage

	public String getValue()
		throws ProcessException, SOAPException
	{

		String resp = null;

		SOAPPart soapPart =
			soapMessage.getSOAPPart();
		SOAPEnvelope soapEnvelope =
			soapPart.getEnvelope();
		SOAPBody soapBody =
			soapEnvelope.getBody();

		Name name;
		name = soapEnvelope.createName(
				"GetValueByNameResponse",
				"pyns",
				"soap-example");

		Iterator valueRequests =
			soapBody.getChildElements(name);

		if (!valueRequests.hasNext())
			throw(new ProcessException());

		SOAPElement soapElement =
			(SOAPElement)valueRequests.next();


		name = soapEnvelope.createName("value");

		Iterator params;

		params = soapElement.getChildElements(name);

		SOAPElement paramElement =
			(SOAPElement)params.next();

		resp = paramElement.getValue();

		if (null == resp)
			throw(new ProcessException());

		return resp;
	}//getValue
}//ResponseMessage